require_relative '../util/submodule'
require_relative '../util/stash'

module DNGG
  module Delete
    include Submodule
    include Stash

    def delete_flow(branch, remote, all)
      check_submodule

      puts '==> 进入主工程：'.yellow

      delete_branch(all, branch, remote)

      foreach_module {
        delete_branch(all, branch, remote)
      }
    end

    def delete_branch(all, branch, remote)
      if branch == get_current_branch
        puts "无法删除当前所在分支：#{branch}，请switch其他分支后再执行\"dngg delete\"".red
        exit 0
      end

      if all
        delete_local_branch(branch)
        delete_remote_branch(branch)
      elsif remote
        delete_remote_branch(branch)
      else
        delete_local_branch(branch)
      end
    end

    def delete_local_branch(branch)
      if `git branch | grep -e '\s|*#{branch}$'`.strip == ''
        puts "warning: branch '#{branch}' not found"
      else
        info = `git branch -D #{branch}`
        if info.strip != ''
          puts "✓  #{info}"
        end
      end
    end

    def delete_remote_branch(branch)
      if `git branch -r | grep -e '\s|*origin/#{branch}$'`.strip == ''
        puts "warning: remote branch '#{branch}' not found"
      else
        system "git push origin -d #{branch}"
        `git fetch -p origin`
      end
    end
  end
end
